from html.parser import HTMLParser
from urllib.request import urlopen


class YouTube:
    y, z = {}, {}

    def mesg(self, msg, t=None):
        self.util.mesg(msg, t)

    def match_urls(self, str):
        r = [
            i
            for i in str.split()
            if "https://youtu.be/" in i
            or "https://www.youtube.com/watch?v=" in i
            or "https://m.youtube.com/watch?v=" in i
            or "https://youtube.com/watch?v=" in i
            or "https://www.youtube.com/embed/" in i
            or "https://www.youtube-nocookie.com/embed/" in i
            or "https://music.youtube.com/watch?v=" in i
        ]
        r = list(dict.fromkeys(r))
        return r

    def is_embed(str):
        return str.startswith("https://www.youtube.com/embed/") or str.startswith(
            "https://www.youtube-nocookie.com/embed/"
        )

    def is_ytmusic(str):
        return str.startswith("https://music.youtube.com/watch?v=")

    class parseprop(HTMLParser):
        def handle_starttag(self, tag, attrs):
            if tag != "meta" or [i for i in attrs if "itemprop" in i] == []:
                return
            global z
            for k, v in attrs:
                if k == "itemprop":
                    if v not in ["name", "duration", "uploadDate", "channelId"]:
                        return
                    x = [v]
                elif k == "content":
                    x += [v]
            z.update({x[0]: x[1]})
            # print(x[0],"=",x[1])

    def fmt_dur(dur):
        h, m, s = 0, 0, 0
        m = dur[2:].split("M")
        s = int(m[1][:-1])
        m = int(m[0])
        if m >= 60:
            h = m // 60
            m = round((m / 60 - h) * 60)
            return f"{h}h {m}m {s}s"
        elif h == 0 and m == 0 and s == 0:
            return "LIVE"
        elif m == 0 and s != 0:
            return f"{s}s"
        else:
            return f"{m}m {s}s"

    def yt(self, url):
        # self.util.mesg("dbg hello")
        url = url.rstrip("\x01")
        if self.is_embed(url):
            videoId = url.split("/")[4]
            url = f"https://www.youtube.com/watch?v={videoId}"
        if self.is_ytmusic(url):
            for i in url.split("?")[1].split("&"):
             if i[0:2]=="v=": videoId=i[2:]
            url = f"https://www.youtube.com/watch?v={videoId}"
        global y, z
        y, z = {}, {}
        p = self.parseprop()
        # url="https://www.youtube.com/watch?v=gyMpI8csWis"
        data = urlopen(url).read().decode()
        p.feed(data)
        if y == z == {}:
            irc_string = "[\x0304Youtube\x03] \x0307ERROR:\x0308 got no data from server! \x0315(check your URL for typos!)\x03"
            ansi_string = "[\x1b[31mYoutube\x1b[0m] \x1b[33;2mERROR:\x1b[33;1m got no data from server! \x1b[37;2m(check your URL for typos!)\x1b[0m"
            print(ansi_string)
            return irc_string
        z.update({"duration": self.fmt_dur(z["duration"])})
        url = f"https://www.youtube.com/channel/{z['channelId']}"
        data = urlopen(url).read().decode()
        y, z = z, {}
        p.feed(data)
        y.update({"channelName": z["name"]})
        y.pop("channelId")
        irc_string = f"[\x0303Youtube\x03] \x02{y['name']}\x02 ({y['duration']}) uploaded by \x1d{y['channelName']}\x1d on {y['uploadDate']}"
        ansi_string = f"[\x1b[32mYoutube\x1b[0m] \x1b[1m{y['name']}\x1b[0m ({y['duration']}) uploaded by \x1b[03m{y['channelName']}\x1b[0m on {y['uploadDate']}"
        print(ansi_string)
        return irc_string


if __name__ == "__main__":
    import sys

    YouTube.yt(YouTube, sys.argv[1])
